;============================================
; PROGRAMMER DR. THIT SIRIBOON
; DATE       30/11/2537
; PURPOSE:  DISPLAY HEX. FROM 00H TO FFH ON SCREEN
;============================================
        .ORG H'100
        LDAA #0       ; START WITH 00H
TOP:
        BSR  SHOWHEX  ; CALL SUBROUTINE THAT SHOW HEX NO.
        PSHA          ; SAVE CONTENT OF ACC. A
        LDAA #' '     ;
        JSR  H'F803   ; PRINT BLANK ON SCREEN
        PULA          ; GET OLD VALUE
        INCA          ; NEXT NUMBER
        BNE   TOP     ; STOP WHEN NO. IS FFH
HERE:   BRA   HERE    ; JUST STAY HERE

;===========================================
; SUBROUTINE SHOWHEX
; DISPLAY CONTENT OF ACC. A AS HEX. ON SCREEN
; INPUT:   BYTE IN ACC. A
; RETURN OUTPUT:   NONE
; REGISTER CHANGE: NONE
; MEMORY CHANGE:   NONE
;============================================
SHOWHEX:
        PSHA         ; SAVE ACC. A
        PSHB         ; SAVE ACC. B
        PSHA         ; SAVE INPUT
        ANDA  #H'F0  ; GET HIGH 4 BITS
        RORA         ;----
        RORA         ;   |- ROTATE 4 TIMES
        RORA         ;   |  TO GET HI. 4 BITS TO LO
        RORA         ;----
        BSR   CHANGE ; DISPLAY
        PULA         ; GET INPUT
        ANDA  #H'0F  ; GET LOW 4 BITS
        BSR  CHANGE  ; DISPLAY
        PULB         ; GET ACC. B OLD VALUE
        PULA         ; GET ACC. A OLD VALUE
        RTS

;===========================================
; SUBROUTINE CHANGE
; DISPLAY CONTENT OF LOW 4 BIT IN ACC. A AS HEX.
; ON SCREEN
; INPUT:   LOW 4 BITS ACC. A ASSUME HI. 4 BITS
;          ARE ZERO'S
; RETURN OUTPUT:   NONE
; REGISTER CHANGE: NONE
; MEMORY CHANGE:   NONE
;============================================
CHANGE:
        CMPA #9      ; IS LOW 4 BITS A-F
        BGT  DOAF    ; YES PROCESS
        ADDA #H'30   ; NO 0-9 ADD 30H
        BRA  SHOW    ; TO CHANGE TO ASCII CODE
DOAF:
        ADDA #'A'-10 ; CHANGE TO ASCII CODE 'A'-'F'
SHOW:
        JSR  H'F803  ; DISPLAY
        RTS
        .END
